 local onUpdate = CreateFrame("Frame")
onUpdate:HookScript("OnUpdate", function(self, elapsed)
	if SDIOutput == true then
		SDItimeElapsed = SDItimeElapsed + elapsed
		while (SDItimeElapsed > 5) do
			SDItimeElapsed = 0
			SDIOutput = false
			SDIFrameTop:Show()
			SDIBuildItems()
		end
	end
end)
 
function SDIScrollBar_Update()
	local line
	local buttonText = {}
	local data = {}
	local text = nil
	local lineplusoffset
	local Classcolor = ""
	FauxScrollFrame_Update(SDIScrollBar,#SDIDataTable,17,16)
	for line=1,17 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(SDIScrollBar)		
		if lineplusoffset <= #SDIDataTable then
			buttonText = SDISplitString(SDIDataTable[lineplusoffset], "%&*")
			getglobal("SDIEntry"..line):SetText(buttonText[1])
			getglobal("SDIEntry"..line):SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", -8, 8)
				GameTooltip:ClearLines()
				for i=1,#SDIDataTable do
					data = SDISplitString(SDIDataTable[i], "%&*")
					text = getglobal("SDIEntry"..line):GetText()
					
					if data[1] == text then
						GameTooltip:AddLine(data[1])
						SDILoadItemsOnMouseOver(data[1])
						break
					end
				end
				if data[5] then
					if tonumber(data[5]) then
						GameTooltip:AddLine(data[2].."\n"..data[3].."\n"..data[4].."\n"..C_Map.GetMapInfo(data[5]).name , 1, 1, 1, 1)
					else
						GameTooltip:AddLine(data[2].."\n"..data[3].."\n"..data[4].."\n"..data[5] , 1, 1, 1, 1)
					end
					GameTooltip:SetMinimumWidth( 260 )
				else
					if data[4] then
						if tonumber(data[4]) then
							GameTooltip:AddLine(data[2].."\n"..data[3].."\n"..C_Map.GetMapInfo(data[4]).name , 1, 1, 1, 1)
						else
							GameTooltip:AddLine(data[2].."\n"..data[3].."\n"..data[4] , 1, 1, 1, 1)
						end
						GameTooltip:SetMinimumWidth( 260 )
					else
						if data[3] then
							if tonumber(data[3]) then
								GameTooltip:AddLine(data[2].."\n"..C_Map.GetMapInfo(data[3]).name , 1, 1, 1, 1)
							else
								GameTooltip:AddLine(data[2].."\n"..data[3] , 1, 1, 1, 1)
							end
							GameTooltip:SetMinimumWidth( 260 )
						else
							if data[2] then
								GameTooltip:AddLine(data[2] , 1, 1, 1, 1)
							end
						end
					end
				end
				GameTooltip:Show()
			end)
			getglobal("SDIEntry"..line):SetScript("OnLeave", function(self)
				if GameTooltip:IsOwned(self) then
					GameTooltip:Hide()
				end
			end)			
			
			getglobal("SDIEntry"..line):SetScript("OnClick", function(self)
				local list = SDISplitString(self:GetText(),"%s")
				PLAYERNAME = list[1]
				SDIITEMScrollBar_Update(self)
				SDIITEMFrameTop:Show()
				SDIITEMFrameTop:SetPoint("LEFT",self:GetParent(),-300,0)
			end)
			
			getglobal("SDIWhisper"..line):SetScript("OnClick", function(self)
				SDIWhisperOnClick(self)
			end)
			getglobal("SDIEntry"..line):Show()
			getglobal("SDIWhisper"..line):Show()
		else
			getglobal("SDIEntry"..line):Hide()
			getglobal("SDIWhisper"..line):Hide()
		end
	end
end
 
 function SDIITEMScrollBar_Update(frame)
	local line
	local ITEMS = {}
	local lineplusoffset
	local data = {}
	local playerItem = {}
	local name = nil
	local name2 = nil
	local text1 = ""

	name2 = frame:GetText()
	name = SDISplitString(name2,"%s")

	for i=1,#SDIITEMData do
		playerItem = SDISplitString(SDIITEMData[i], "%s")
		if playerItem[1] == name[1] then
			table.remove(playerItem, 1)
			break
		end
	end
	FauxScrollFrame_Update(SDIITEMScrollBar,#playerItem,17,16)
	for line=1,17 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(SDIITEMScrollBar)
		if lineplusoffset <= #playerItem then
			SDISetItemRarityColor(playerItem[lineplusoffset],getglobal("SDIITEM"..line))
			
			getglobal("SDIITEM"..line):SetScript("OnEnter", function(self)
				local itemName = nil
				GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", -8, 8)
				for i=1,#SDIITEMLinks do
					local data = SDISplitString(SDIITEMLinks[i],"%s")
					if data[1] == PLAYERNAME then
						if data[3] and data[2] then
							local item = SDISplitString(data[3],"%:")
							if item[2] then
								local itemid = item[2]..":"..data[2]
								local text = self:GetText()
								if string.find(text, SDISetItemRarityColor(itemid)) then
									GameTooltip:SetHyperlink(data[3])
									GameTooltip:Show()
									break
								end
							end
						end
					end
					if GameTooltip:IsVisible() then
						break
					end
				end
				--[[
				for i=1,#SDIITEMData do
					local data = SDISplitString(SDIITEMData[i], "%s")
					if i==1 then
						table.remove(data, 1)
					end
					local text = getglobal("SDIITEM"..line):GetText()
					for j=1,#data do
						if SDISetItemRarityColor(data[j]) ~= nil then
							if string.find(text,SDISetItemRarityColor(data[j])) then
								local itemIDClean = SDISplitString(data[j], "%:")
								GameTooltip:SetHyperlink("item:"..itemIDClean[1])
								GameTooltip:Show()
								break
							end
						end
					end
					if GameTooltip:IsVisible() then
						break
					end]]--
				--end
			end)
			getglobal("SDIITEM"..line):SetScript("OnLeave", function(self)
				if GameTooltip:IsOwned(self) then
					GameTooltip:Hide()
				end
			end)
			getglobal("SDIITEM"..line):Show()
		else
			getglobal("SDIITEM"..line):Hide()
		end
	end
 end
 
 function SDIWhisperOnClick(frame)
	if frame then
		local e = DEFAULT_CHAT_FRAME.editBox
		local parent = frame:GetParent()
		local name = parent:GetText()
		local realname = {}
		realname = SDISplitString(name,"%s")
		realname[1] = string.gsub( realname[1], "|c%x%x%x%x%x%x%x%x", "" )
		realname[1] = string.gsub( realname[1], "|r", "" )
		ChatEdit_ActivateChat(e)
		e:SetText("/w "..realname[1].." ")
	end
end
function SDIBuildItems()
	local playerItem = ""
	local enchItem = {}
	local gemsItem = {}
	local suffixItem = {}
	local itemLink = ""
	local check = true
	local gemlink = ""
	local itemandslot = {}
	local enchandslot = {}
	local gemandslot = {}
	local suffandslot = {}
	local emptynumber = 0
	local gemline = ""
	local gemslink = {}	
	for i=1,#SDIITEMData do	
		playerItem = SDISplitString(SDIITEMData[i], "%s")
		gemsItem = nil
		enchItem = nil
		suffixItem = nil
		if SDIITEMEnch then
			for j=1,#SDIITEMEnch do
				local subenchItem = SDISplitString(SDIITEMEnch[j],"%s")
				if subenchItem[1] == playerItem[1] then
					enchItem = subenchItem
					break
				end
			end
			if enchItem then
				table.remove(enchItem,1)
			end
		end
		if SDIITEMGEMS then
			for j=1,#SDIITEMGEMS do
				local subgemsItem = SDISplitString(SDIITEMGEMS[j],"%s")
				if subgemsItem[1] == playerItem[1] then
					gemsItem = subgemsItem
					break
				end
			end
			if gemsItem then
				table.remove(gemsItem,1)
			end
		end
		if SDIITEMSuff then
			for j=1,#SDIITEMSuff do
				local subsuffixItem = SDISplitString(SDIITEMSuff[j],"%s")
				if subsuffixItem[1] == playerItem[1] then
					suffixItem = subsuffixItem
					break
				end
			end
			if suffixItem then
				table.remove(suffixItem,1)
			end
		end
		if playerItem then
			for j=1,#playerItem do
				if j > 1 then
					itemandslot = SDISplitString(playerItem[j],"%:")
					itemLink = "item:"..itemandslot[1]
					if enchItem then
						for k=1,#enchItem do
							enchandslot = SDISplitString(enchItem[k],"%:")
							if enchandslot[2] then
								if enchandslot[2] == itemandslot[2] then
									itemLink = itemLink..":"..enchandslot[1]
									check = true
									break
								else
									check = false
								end
							else
								check = false
							end
						end
						if check == false then
							itemLink = itemLink..":"
						end
					else
						itemLink = itemLink..":"
					end
					if gemsItem then
						for k=1,#gemsItem do
							gemandslot = SDISplitString(gemsItem[k],"%:")
							if gemandslot[2] then
								if gemandslot[2] == itemandslot[2] then
									if gemlink == "" then
										gemlink = ":"..gemandslot[1]
									else
										gemlink = gemlink..":"..gemandslot[1]
									end
								end
							end
						end
					end
					if gemlink ~= "" then
						itemLink = itemLink..gemlink
						gemslink = SDISplitString(gemlink, "%:")
						emptynumber = 4 - #gemslink 
						if emptynumber > 0 then
							for k=1,emptynumber do
								itemLink = itemLink..":"
							end
						end
						gemlink = ""
					else
						itemLink = itemLink..":"..":"..":"..":"
					end
					if suffixItem then
						for k=1,#suffixItem do
							suffandslot = SDISplitString(suffixItem[k],"%:")
							if suffandslot[2] then
								if suffandslot[2] == itemandslot[2] then
									itemLink = itemLink..":"..suffandslot[1]
									check = true
									break
								else
									check = false
								end
							else
								check = false
							end
						end
						if check == false then
							itemLink = itemLink..":"
						end
					else
						itemLink = itemLink..":"
					end
				end
				if itemandslot[2] and itemLink then
					table.insert(SDIITEMLinks,playerItem[1].." "..itemandslot[2].." "..itemLink)
				end
			end
		end
	end
 end
 
 function SDISetItemRarityColor(itemID,frame)
	local itemIDClean = SDISplitString(itemID, "%:")
	if frame then
		local itemName,a,itemQuality,p,c,d,e,f,g,h,i,j,k,l,m,n,o = GetItemInfo(itemIDClean[1])
		if itemQuality then
			local r,g,b,h = GetItemQualityColor(itemQuality)	
			frame:SetText("|c"..h..itemName.."|r")
		end
	else
		local itemName,a,itemQuality,p,c,d,e,f,g,h,i,j,k,l,m,n,o = GetItemInfo(itemIDClean[1])
		if itemQuality then
			local r,g,b,h = GetItemQualityColor(itemQuality)
			return "|c"..h..itemName.."|r"
		end
	end
 end
 
 function SDILoadItemsOnMouseOver(coloredname)
	local itemlist = SDIITEMData
	local name = SDISplitString(coloredname, "%s")
	local items = {}
	for i=1,#itemlist do
		items = SDISplitString(itemlist[i], "%s")
		if items[1] == name then
			table.remove(items,1)
			break
		end
	end
	for i=1,#items do
		if items[i] ~= nil then
			local itemid = SDISplitString(items[i],"%:")
			SDISetItemRarityColor(itemid[1])
		end
	end
 end
 
 function SDIScroll_OnLoad()
	SDIScrollBar:Show()
 end


 local function SDIChatFilter(self, event, msg, author, ...)
  if msg:find("!SDI") then
    return true
  end
 end
 ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", SDIChatFilter)
 ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", SDIChatFilter)
 ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", SDIChatFilter)
 
 function SDISplitString(inputstr, sep)
	if sep == nil then
		sep = "%s"
	end
	local result={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		table.insert(result, str)
	end
	return result
 end
 
 function SDISetPlayerClassColor(pname) 
	local numTotalGuildMembers, numOnlineGuildMembers, numOnlineAndMobileMembers = GetNumGuildMembers()
	local tname = {}
	local class = ""
	for i=1, numOnlineGuildMembers do
		name,b,c,d,e,f,g,h,i,j,cl = GetGuildRosterInfo(i)
		tname = SDISplitString(name, "-")
		if tname[1] == pname then
			class = cl
		end
	end
	if class == "DRUID" then
		return "|c00FF7C0A"..pname.."|r"
	end
	if class == "HUNTER" then
		return"|c00AAD372"..pname.."|r"
	end	
	if class == "MAGE" then
		return "|c003FC7EB"..pname.."|r"
	end	
	if class == "PALADIN" then
		return "|c00F48CBA"..pname.."|r"
	end	
	if class == "PRIEST" then
		return "|c00FFFFFF"..pname.."|r"
	end	
	if class == "ROGUE" then
		return "|c00FFF468"..pname.."|r"
	end	
	if class == "SHAMAN" then
		return "|c000070DD"..pname.."|r"
	end	
	if class == "WARLOCK" then
		return "|c008788EE"..pname.."|r"
	end	
	if class == "WARRIOR" then
		return "|c00C69B6D"..pname.."|r"
	end
 end
 
 function SDIITEMS_OnClick()
 	for i=1,17 do
		getglobal("SDIITEM"..i):SetText("")
	end
	SDIITEMFrameTop:Hide()
 end
 
 function SDIPlayers_OnClick()
	SDItimeElapsed = 0
	SDIOutput = false
	SDIDataTable = {}
	SDIITEMIEnch = {}
	SDIITEMIGEMS = {}
	SDIITEMISuff = {}
	SDIITEMLinks = {}
	SDIITEMData = {}
	SDIIDs = {}
	SDIFrameTop:Hide()
 end
