local EventFrame = CreateFrame("frame", "EventFrame")
local EventFrame2 = CreateFrame("frame", "EventFrame2")
local timeToday = ""
local SDIRoles = ""
local L = SDILocalizationTable
local waitTable = {};
local waitFrame = nil;
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame2:RegisterEvent("CHAT_MSG_ADDON")


EventFrame:SetScript("OnEvent", function(self, event, text, player, ...)
	local testdate = date("%y%m%d")
	if event == "PLAYER_ENTERING_WORLD" then
		C_ChatInfo.RegisterAddonMessagePrefix("SDIGETDATA")
		C_ChatInfo.RegisterAddonMessagePrefix("SDIDATA")
		C_ChatInfo.RegisterAddonMessagePrefix("SDIITEMDATA")
		C_ChatInfo.RegisterAddonMessagePrefix("SDIITEMENCH")
		C_ChatInfo.RegisterAddonMessagePrefix("SDIITEMGEMS")
		C_ChatInfo.RegisterAddonMessagePrefix("SDIITEMSUFF")
		if SDIQ == true or SDIQFlag == true then 
			QFlag = true
		end			
		if SDIlastseen == nil then
			SDIlastseen = date("%y%m%d")
			SDIQFlag = false
			SDIConfigFrame:Show()
		end
		if SDIlastseen < testdate and date("%H") > "05" then
			if SDIshow == true then
				SDIlastseen = date("%y%m%d")
				SDIConfigFrame:Show()
				SDIbox9:SetText("")
				SDIzusatzinfo = ""
			end
			if SDIQ == false then
				SDIQFlag = false
			else
				SDIQFlag = true
			end	
		end
	end
	if event == "PLAYER_LOGIN" then
		print(L["loginmessage"])
	end
end)

EventFrame2:SetScript("OnEvent", function(self,event,prefix,text,channel,sender, ...)
	local player = {} 
	local name = ""
	local SDIItems = {}
	local SDIEnchants = {}
	local SDIGems = {}
	local SDISuffixes = {}
	local itemMessage = ""
	local enchMessage = ""
	local suffMessage = ""
	local gemsMessage = ""
	local name,realm = UnitFullName("player")
	local fullName = name .. "-" .. realm
	local playerItem = {}
	local SDIids = SDIGetSavedInstances()
	
	if event == "CHAT_MSG_ADDON" and ( fullName ~= sender or fullName == "Destru-Venoxis") then
		if prefix == "SDIGETDATA" then
			if QFlag == true then
				SDIGetTimeWeekday()
				SDIRoles = SDISetRoles()
				local isinparty = ""
				if UnitInParty("player") == true then
					isinparty = "|c00FF0000in party|r"
				else
					isinparty = "|c0000FF00no party|r"
				end
				C_ChatInfo.SendAddonMessage("SDIDATA", SDIRoles.."&*"..timeToday.."&*"..SDIzusatzinfo.."&*"..isinparty.."&*"..tostring(C_Map.GetBestMapForUnit("player")), "WHISPER", sender)
				SDIItems,SDIEnchants,SDIGems,SDISuffixes = SDIGetPlayersItemsAll()
				for i=1,17 do
					if i == 1 then
						if SDIItems[i] then
							itemMessage = SDIItems[i]
						end
						if SDIEnchants[i] then
							enchMessage = SDIEnchants[i]
						end
						if SDISuffixes[i] then
							suffMessage = SDISuffixes[i]
						end
					else
						if SDIItems[i] then
							itemMessage = itemMessage.." "..SDIItems[i]
						end
						if SDIEnchants[i] then
							enchMessage = enchMessage.." "..SDIEnchants[i]
						end
						if SDISuffixes[i] then
							suffMessage = suffMessage.." "..SDISuffixes[i]
						end						
					end
				end
				if SDIGems then
					for i=1,#SDIGems do
						if i == 1 then
							gemsMessage = SDIGems[i]
						else
							gemsMessage = gemsMessage.." "..SDIGems[i]
						end
					end
				end
				SDIwait(0.15, C_ChatInfo.SendAddonMessage("SDIITEMDATA", itemMessage, "WHISPER", sender), ...)
				--C_ChatInfo.SendAddonMessage("SDIITEMDATA", itemMessage, "WHISPER", sender)
				SDIwait(0.15,C_ChatInfo.SendAddonMessage("SDIITEMENCH", enchMessage, "WHISPER", sender), ...)
				--C_ChatInfo.SendAddonMessage("SDIITEMENCH", enchMessage, "WHISPER", sender)
				SDIwait(0.15,C_ChatInfo.SendAddonMessage("SDIITEMGEMS", gemsMessage, "WHISPER", sender), ...)
				--C_ChatInfo.SendAddonMessage("SDIITEMGEMS", gemsMessage, "WHISPER", sender)
				SDIwait(0.15,C_ChatInfo.SendAddonMessage("SDIITEMSUFF", suffMessage, "WHISPER", sender), ...)
				--C_ChatInfo.SendAddonMessage("SDIITEMSUFF", suffMessage, "WHISPER", sender)
				if SDIids then
					SDIwait(0.15,C_ChatInfo.SendAddonMessage("SDIIIDS", SDIids, "WHISPER", sender), ...) 
				end
			end			
		end
		if prefix == "SDIITEMDATA" then
			name = SDIGetNamePlayer(sender)
			if name then
				playerItem = SDISplitString(text, "%s")
				for i=1,#playerItem do
					--Items laden
					if playerItem[i] ~= nil then
						local itemid = SDISplitString(playerItem[i],"%:")
						SDISetItemRarityColor(itemid[1])
					end
				end	
				table.insert(SDIITEMData,name.." "..text)
			end
		end
		if prefix == "SDIDATA" then
			name = SDIGetNamePlayer(sender)
			if name then
				table.insert(SDIDataTable, name.." "..text)
			end
		end
		if prefix == "SDIITEMENCH" then
			name = SDIGetNamePlayer(sender)
			if name then
				table.insert(SDIITEMEnch, name.." "..text)
			end
		end
		if prefix == "SDIITEMGEMS" then
			name = SDIGetNamePlayer(sender)
			if name then
				local gems = SDISplitString(text,"%s")
				local gemline = ""
				for i=1,#gems do
					if i == 1 then
						gemline = gems[i]
					else
						gemline = gemline.." "..gems[i]
					end
				end
				table.insert(SDIITEMGEMS, name.." "..gemline)
			end
		end
		if prefix == "SDIITEMSUFF" then
			name = SDIGetNamePlayer(sender)
			if name then
				table.insert(SDIITEMSuff, name.." "..text)
			end
		end
		if prefix == "SDIIDS" then
			name = SDIGetNamePlayer(sender)
			if name then
				table.insert(SDIIDs, name.." "..text)
			end
		end
	end
end)

function SDIGetNamePlayer(s)
	local player = SDISplitString(s, "%-") 
	local name = SDISetPlayerClassColor(player[1])
	return name
end
--[[function GetPlayersItems()
	local itemList = {}
	for i=1,18 do 
		if i ~= 4 then
			local itemID = GetInventoryItemID("player",i)
			local enchantID = GetInventoryItem
			if itemID then
				table.insert(itemList,itemID ..":"..i)
			end
		end
	end
	return itemList
end
]]--

function SDIGetPlayersItemsAll()
	local itemValues = {}
	local itemList = {}
	local itemEnchants = {}
	local itemGems = {}
	local itemSuffix = {}
	for i=1,18 do 
		if i ~= 4 then
			local itemLink = GetInventoryItemLink("player",i)
			itemValues = {}
			if itemLink then
				for k, v in pairs({strsplit(":", itemLink)}) do
					if not v then
						v = "0"
					end
					table.insert(itemValues,v)
				end
				if itemValues then
					table.remove(itemValues,1)
					table.insert(itemList,itemValues[1]..":"..i)
					table.insert(itemEnchants,itemValues[2]..":"..i)
					table.insert(itemGems,itemValues[3]..":"..i)
					table.insert(itemGems,itemValues[4]..":"..i)
					table.insert(itemGems,itemValues[5]..":"..i)
					table.insert(itemGems,itemValues[6]..":"..i)
					table.insert(itemSuffix,itemValues[7]..":"..i)	
				end
			end
		end
	end
	return itemList,itemEnchants,itemGems,itemSuffix
end

function SDIGetSavedInstances()
	local instanceID,instanceGroupSize,LfgDungeonID  = GetInstanceInfo()
	local pname = SDIGetNamePlayer(UnitName("player"))
	local SDIIds = ""
	for i=1,GetNumSavedInstances() do 
		local name, id, reset, difficulty, locked = GetSavedInstanceInfo(i)
		local n, gT, isHeroic = GetDifficultyInfo(difficulty)
		if isHeroic == true and locked == true then
			if name == GetRealZoneText(558) then --	Auchenai Crypts
				SDIIds = SDIIds.." ".."558"
			end
			if name == GetRealZoneText(543) then --	Hellfire Ramparts
				SDIIds = SDIIds.." ".."543"
			end
			if name == GetRealZoneText(585) then --	Magisters' Terrace
				SDIIds = SDIIds.." ".."585"
			end
			if name == GetRealZoneText(557) then --	Mana-Tombs
				SDIIds = SDIIds.." ".."557"
			end
			if name == GetRealZoneText(560) then --	Old Hillsbrad Foothills
				SDIIds = SDIIds.." ".."560"
			end
			if name == GetRealZoneText(556) then --	Sethekk Halls
				SDIIds = SDIIds.." ".."556"
			end
			if name == GetRealZoneText(555) then --	Shadow Labyrinth
				SDIIds = SDIIds.." ".."555"
			end
			if name == GetRealZoneText(552) then --	The Arcatraz
				SDIIds = SDIIds.." ".."552"
			end
			if name == GetRealZoneText(269) then --	The Black Morass
				SDIIds = SDIIds.." ".."269"
			end
			if name == GetRealZoneText(542) then --	The Blood Furnace
				SDIIds = SDIIds.." ".."542"
			end
			if name == GetRealZoneText(553) then --	The Botanica
				SDIIds = SDIIds.." ".."553"
			end
			if name == GetRealZoneText(554) then --	The Mechanar
				SDIIds = SDIIds.." ".."554"
			end
			if name == GetRealZoneText(540) then --	The Shattered Halls
				SDIIds = SDIIds.." ".."540"
			end
			if name == GetRealZoneText(547) then --	The Slave Pens
				SDIIds = SDIIds.." ".."547"
			end
			if name == GetRealZoneText(545) then --	The Steamvault
				SDIIds = SDIIds.." ".."545"
			end
			if name == GetRealZoneText(546) then --	The Underbog
				SDIIds = SDIIds.." ".."546"
			end
		end
		if SDIIds ~= "" then
			SDIIds = pname.." "..SDIIds
			return SDIIds
		end
	end
end

function SDIGetTimeWeekday()
	local d = date("*t")
	if d.wday == 2 then
		timeToday = SDImo
	end
	if d.wday == 3 then
		timeToday = SDIdi
	end
	if d.wday == 4 then
		timeToday = SDImi
	end
	if d.wday == 5 then
		timeToday = SDIdon
	end
	if d.wday == 6 then
		timeToday = SDIfr
	end
	if d.wday == 7 then
		timeToday = SDIsa
	end
	if d.wday == 1 then
		timeToday = SDIso
	end
end

function SDISetRoles()
	local heal,tank,dps = "","",""
	
	if SDIRoleHeal == true then
		heal = "|cffff8000[Heal] |r"
	end
	if SDIRoleTank == true then
		tank = "|cffa335ee[Tank] |r"
	end
	if SDIRoleDPS == true then
		dps = "|cdd808080[DPS]|r"
	end
	return heal..tank..dps
end